// Setup variables
var base, knob1, knob2, knob3, send_button, up_button, down_button;
var textfont;

var knob1_x = 108,
knob1_y = 135,
knob1_width,
knob1_height,
knob1_clicked = 0,
knob2_x = 102,
knob2_y = 293,
knob2_width,
knob2_height,
knob2_clicked = 0,
knob3_x = 107,
knob3_y = 460,
knob3_width,
knob3_height,
knob3_clicked = 0,
send_button_x = 170,
send_button_y = 588,
send_button_width,
send_button_height,
send_button_clicked_time = 0,
up_button_x = 585,
up_button_y = 592,
up_button_width,
up_button_height,
up_button_clicked_time = 0,
down_button_x = 718,
down_button_y = 596,
down_button_width,
down_button_height,
down_button_clicked_time = 0;

// Setup game state
window.game_data = {};
window.game_data.ajax_running = false;
window.game_data.current_x = 0.0;
window.game_data.current_y = 0.0;
window.game_data.current_z = 0.0;

window.game_data.current_message = 0;
window.game_data.messages = [
	{
		content: 'Device ready to transmit.',
		type: 'text',
		tags: []
	}
];
window.game_data.hints = [];

var state = 0, score = 0, end_time = 0, fail_timer = 0;

// Bright yellow makecol(255, 200, 0)
// Bright orange makecol(160, 130, 0)
// Dim orange makecol(180, 160, 0)
// Dark orange makecol(80, 60, 0)
// Black orange makecol(40, 30, 0)

function draw() {
	clear_to_color(canvas,makecol(128, 128, 128));

	// Draw screens
	draw_screen(303, 126, 174, 116, 16.0, window.game_data.current_x, 'x', window.game_data.hints);
	draw_screen(303, 288, 174, 116, 8.0, window.game_data.current_y, 'y', window.game_data.hints);
	draw_screen(303, 450, 174, 116, 4.0, window.game_data.current_z, 'z', window.game_data.hints);

	if (window.game_data.ajax_running == true) {
		draw_text_screen(545, 126, 350, 443, 'Sending transmission...', 'Message ' + (window.game_data.current_message + 1) + '/' + window.game_data.messages.length);
	} else {
		draw_text_screen(545, 126, 350, 443, window.game_data.messages[window.game_data.current_message].content, 'Message ' + (window.game_data.current_message + 1) + '/' + window.game_data.messages.length);
	}

	// Draw consol base
	simple_blit(base, canvas, 0, 0);

	if (time()%2 == 0) {
		//simple_blit(down_button, canvas, mouse_x, mouse_y);
	}

	// Draw alternate controls if clicked
	if (knob1_clicked && time()%2 == 0) {
		simple_blit(knob1, canvas, knob1_x, knob1_y);
	}
	knob1_clicked = 0;

	if (knob2_clicked && time()%2 == 0) {
		simple_blit(knob2, canvas, knob2_x, knob2_y);
	}
	knob2_clicked = 0;

	if (knob3_clicked && time()%2 == 0) {
		simple_blit(knob3, canvas, knob3_x, knob3_y);
	}
	knob3_clicked = 0;

	if (send_button_clicked_time > time()) {
		simple_blit(send_button, canvas, send_button_x, send_button_y);
	}
	if (up_button_clicked_time > time()) {
		simple_blit(up_button, canvas, up_button_x, up_button_y);
	}
	if (down_button_clicked_time > time()) {
		simple_blit(down_button, canvas, down_button_x, down_button_y);
	}
}

function update() {
	if (mouse_b&1 && time()%2 == 0) {
		/**
		 * Knob fiddling
		 */
		// Increase X
		if (mouse_x > knob1_x + knob1_width/2 && mouse_x < knob1_x + knob1_width && mouse_y > knob1_y && mouse_y < knob1_y + knob1_height) {
			knob1_clicked = 1;

			window.game_data.current_x = Math.min(180.0, window.game_data.current_x + 1.0);
		}

		// Decrease X
		if (mouse_x > knob1_x && mouse_x < knob1_x + knob1_width/2 && mouse_y > knob1_y && mouse_y < knob1_y + knob1_height) {
			knob1_clicked = 1;

			window.game_data.current_x = Math.max(-180.0, window.game_data.current_x - 1.0);
		}

		// Increase Y
		if (mouse_x > knob2_x + knob2_width/2 && mouse_x < knob2_x + knob2_width && mouse_y > knob2_y && mouse_y < knob2_y + knob2_height) {
			knob2_clicked = 1;

			window.game_data.current_y = Math.min(180.0, window.game_data.current_y + 1.0);
		}

		// Decrease Y
		if (mouse_x > knob2_x && mouse_x < knob2_x + knob2_width/2 && mouse_y > knob2_y && mouse_y < knob2_y + knob2_height) {
			knob2_clicked = 1;

			window.game_data.current_y = Math.max(-180.0, window.game_data.current_y - 1.0);
		}

		// Increase Z
		if (mouse_x > knob3_x + knob3_width/2 && mouse_x < knob3_x + knob3_width && mouse_y > knob3_y && mouse_y < knob3_y + knob3_height) {
			knob3_clicked = 1;

			window.game_data.current_z = Math.min(180.0, window.game_data.current_z + 1.0);
		}

		// Decrease Z
		if (mouse_x > knob3_x && mouse_x < knob3_x + knob3_width/2 && mouse_y > knob3_y && mouse_y < knob3_y + knob3_height) {
			knob3_clicked = 1;

			window.game_data.current_z = Math.max(-180.0, window.game_data.current_z - 1.0);
		}
	}

	if (mouse_pressed) {
		/**
		 * Transmit scan
		 */
		if (mouse_x > send_button_x && mouse_x < send_button_x + send_button_width && mouse_y > send_button_y && mouse_y < send_button_y + send_button_height) {
			send_button_clicked_time = time() + 50;

			// Check that there is no AJAX request currently running
			if (window.game_data.ajax_running == false) {
				// Update AJAX status
				window.game_data.ajax_running = true;

				var jqxhr = $.getJSON(
					game_settings.transmit_url + '/' + window.game_data.current_x + '/' + window.game_data.current_y + '/' + window.game_data.current_z + '.json',
					function(data, textStatus, jqXHR) {
						// Set coordinates if available
						if (data.hasOwnProperty('coordinates')) {
							window.game_data.current_x = data.coordinates.x;
							window.game_data.current_y = data.coordinates.y;
							window.game_data.current_z = data.coordinates.z;
						}

						// Add new messages if available
						if (data.hasOwnProperty('messages')) {
							for (var i = 0; i < data.messages.length; i++) {
								window.game_data.messages.push(data.messages[i]);
							};
						}

						// Set hints if available
						if (data.hasOwnProperty('hints')) {
							window.game_data.hints = data.hints
						}
					}
				)
				.fail(
					function(jqxhr, textStatus, error) {
						console.log('AJAX error: ' + textStatus + ', ' + error);

						window.game_data.messages.push({
							content: 'Device error: ' + textStatus + ', ' + error,
							type: 'text',
							tags: ['warning']
						});
					}
				)
				.always(
					function() {
						// Advance to new message or stay at the end if no new messages were added
						window.game_data.current_message = Math.min(window.game_data.messages.length - 1, window.game_data.current_message + 1);

						// Update AJAX status
						window.game_data.ajax_running = false;
					}
				);
			}
		}

		/**
		 * Messages
		 */
		// Next message
		if (mouse_x > down_button_x && mouse_x < down_button_x + down_button_width && mouse_y > down_button_y && mouse_y < down_button_y + down_button_height) {
			down_button_clicked_time = time() + 50;

			window.game_data.current_message = Math.min(window.game_data.messages.length - 1, window.game_data.current_message + 1);
		}

		// Previous message
		if (mouse_x > up_button_x && mouse_x < up_button_x + up_button_width && mouse_y > up_button_y && mouse_y < up_button_y + up_button_height) {
			up_button_clicked_time = time() + 50;

			window.game_data.current_message = Math.max(0, window.game_data.current_message - 1);
		}
	}
}

/**
 * [draw_screen description]
 * @param  int screen_x        [description]
 * @param  int screen_y        [description]
 * @param  int screen_width    [description]
 * @param  int screen_height   [description]
 * @param  float phase         Phase values 4.0 to 16.0 look good
 * @param  float screen_value  Value of dimension with value between -180.0 to 180.0
 * @param  string label        'x', 'y' or 'z'
 * @param  array screen_hints  Array of hint objects with keys x, y and z with float values between -0.98 and 0.98
 * @return void
 */
function draw_screen(screen_x, screen_y, screen_width, screen_height, phase, screen_value, label, screen_hints) {
	// Draw bright orange background
	rectfill(canvas, screen_x, screen_y, screen_width, screen_height, makecol(40, 30, 0));

	// Draw zero lines
	vline(canvas, screen_x + screen_width / 2, screen_y, screen_y + screen_height, makecol(80, 60, 0), 1);
	hline(canvas, screen_x, screen_y + screen_height / 2, screen_x + screen_width, makecol(80, 60, 0), 1);

	var dot_count = 100,
		max_scale = 8.0;
	for (var i = 1; i < dot_count; i++) {
		// Draw first hint
		if (screen_hints.length > 0) {
			var firstHint = screen_hints[0];

			var value = scale(firstHint[label], -1.0, 1.0, 2.0, max_scale);

			circlefill(
				canvas,
				screen_x + (frand() * 20) - 10 + i * screen_width / dot_count,
				screen_y + (frand() * 20) - 10 + Math.sin((time() / 1000) + i / phase) * screen_height / value + screen_height / 2.0,
				1,
				makecol(180, 160, 0)
			);
		}

		// Draw current line
		var value = scale(screen_value, -180.0, 180.0, 2.0, max_scale);
		line(
			canvas,
			screen_x + i * screen_width / dot_count,
			screen_y + Math.sin((time() / 1000) + i / phase) * screen_height / value + screen_height / 2.0,
			screen_x + (i - 1) * screen_width / dot_count,
			screen_y + Math.sin((time() / 1000) + (i - 1) / phase) * screen_height / value + screen_height / 2.0,
			makecol(160, 130, 0),
			2
		);

	};

	// Draw curren value
	textout(canvas, textfont, label + ": " + screen_value.toFixed(2), screen_x + 7, screen_y + screen_height - 9, 12, makecol(180, 160, 0), makecol(160, 130, 0), 0);
}

function draw_text_screen(screen_x, screen_y, screen_width, screen_height, content_text, status_text) {
	var screen_area = create_bitmap(screen_width, screen_height);

	// Draw bright orange background
	rectfill(screen_area, 0, 0, screen_width, screen_height, makecol(40, 30, 0));

	// Split message content by line breaks and line length
	var final_lines = [], lines = content_text.split('\n');
	for (var i = 0; i < lines.length; i++) {
		if (lines[i].length > 40) {
			var temp_lines = lines[i].match(/.{1,40}/g); // 40 characters seems to work with 15px fluid width font
			for (var i = 0; i < temp_lines.length; i++) {
				final_lines.push(temp_lines[i]);
			};
		} else {
			final_lines.push(lines[i]);
		}
	};

	// Draw message content
	for (var i = 0; i < final_lines.length; i++) {
		textout(screen_area, textfont, final_lines[i], 5, 20 + i * 15, 15, makecol(180, 160, 0), makecol(160, 130, 0), 0);
	};

	// Draw status text line
	hline(screen_area, 0, screen_height - 50, screen_width, makecol(80, 60, 0), 1);

	// Draw message content
	textout_centre(screen_area, textfont, status_text, screen_width / 2, screen_height - 21, 15, makecol(180, 160, 0), makecol(160, 130, 0), 0);

	simple_blit(screen_area, canvas, screen_x, screen_y);
}

function main() {
	//enable_debug('debug_box');
	allegro_init_all("game_canvas", 1024, 826);

	textfont = create_font('sans-serif');
	base = load_bmp('img/game_assets/base.png');
	knob1 = load_bmp('img/game_assets/knob1.png');
	knob2 = load_bmp('img/game_assets/knob2.png');
	knob3 = load_bmp('img/game_assets/knob3.png');
	send_button = load_bmp('img/game_assets/send_button.png');
	up_button = load_bmp('img/game_assets/up_button.png');
	down_button = load_bmp('img/game_assets/down_button.png');
	
	ready(function(){
		// Setup stuff from loaded media
		//ukko_korkeus = ukko.canvas.height;
		knob1_width = knob1.canvas.width;
		knob1_height = knob1.canvas.height;
		knob2_width = knob2.canvas.width;
		knob2_height = knob2.canvas.height;
		knob3_width = knob3.canvas.width;
		knob3_height = knob3.canvas.height;
		send_button_width = send_button.canvas.width;
		send_button_height = send_button.canvas.height;
		up_button_width = up_button.canvas.width;
		up_button_height = up_button.canvas.height;
		down_button_width = down_button.canvas.width;
		down_button_height = down_button.canvas.height;

		loop(function(){
			update();
			draw();
		},BPS_TO_TIMER(60));
	});
	return 0;
}
END_OF_MAIN();
